<?php
/**
 * ----------------------------------------------
 * Advanced Poll 2.0 (PHP)
 * Copyright (c)2001 Chi Kien Uong
 * URL: http://www.proxy2.de
 * ----------------------------------------------
 */

class pollcomment extends poll {

    var $poll_comment_html = array();

    function pollcomment() {
        $this->poll();
    }

    function show_form($poll_id) {
        if (!isset($this->poll_comment_html[$poll_id]) || !isset($this->poll_comment_html[$poll_id][$this->template_set])) {
            $line = file("$this->include_path/polldata/$poll_id");
            list($question,$timestamp,$exp_time,$expire,$logging,$status,$comments) = split("\\|",$line[0]);
            $question = htmlspecialchars($question);            
            eval("\$result_html = \"".$this->get_poll_tpl("comment")."\";");
            $this->poll_comment_html[$poll_id][$this->template_set] = $result_html;
        }
        return $this->poll_comment_html[$poll_id][$this->template_set];
    }

    function format_string($strg) {
        if (get_magic_quotes_gpc()) {
            $strg = stripslashes($strg);
        }
        $strg = trim($strg);
        $strg = htmlspecialchars($strg);
        $strg = str_replace("","",$strg);
        $strg = str_replace("\r\n","<br>",$strg);
        $strg = str_replace("\n","<br>",$strg);
        return $strg;
    }

    function add_comment($poll_id) {
        global $name, $email, $message;
        $name = $this->format_string($name);
        if (!$name) {
            $name = "anonymous";
        }
        $email = $this->format_string($email);
        $message = $this->format_string($message);
        if (!eregi("^[_a-z0-9-]+(\\.[_a-z0-9-]+)*@([0-9a-z][0-9a-z-]*[0-9a-z]\\.)+[a-z]{2,6}$", $email) ) {
            $email = '';
        }
        $this_time = time();
        $host = gethostbyaddr($this->ip);
        $agent = @getenv("HTTP_USER_AGENT");
        $entry = "$this_time".""."$host".""."$agent".""."$name".""."$email".""."$message\n";
        $comment_table = fopen("$this->include_path/polldata/$poll_id.dat","a");
        flock($comment_table,2);
        fwrite($comment_table,"$entry");
        flock($comment_table,3);
        fclose($comment_table);    
        return ($comment_table) ? true : false;
    }

    function print_message($strg,$autoclose=0) {
        $msg ='';
        if ($autoclose==1) {
            $msg .= "<script language=\"JavaScript\">
            setTimeout(\"closeWin()\",2000);
            function closeWin() {
                self.close();
            }
            </script>";
        }
        $msg .= "<font face=\"Verdana, Arial, Helvetica, sans-serif\" size=\"1\">$strg</font>";
        return $msg;
    }

    function is_comment_allowed($poll_id) {
        if ($poll_id>0) {
            $line = file("$this->include_path/polldata/$poll_id");
            list($question,$timestamp,$exp_time,$expire,$logging,$status,$comments) = split("\\|",$line[0]);
            return ($comments==1) ? true : false;
        } else {
            return false;
        }
    }
    
    function comment_process($poll_id) {
        global $message, $action;
        $message = trim($message);
        if (!isset($action)) {
            $action='';
        }
        if (!isset($poll_id)) {
            return $this->print_message("Poll ID <b>".$poll_id."</b> does not exist or is disabled!");
        }
        if ($action == "add" && $this->is_comment_allowed($poll_id)) {
            if (empty($message)) {
                return $this->print_message("You forgot to fill in the message field!<br><a href=\"javascript:history.back()\">Go back</a>");
            } else {
                $this->add_comment($poll_id);
                return $this->print_message("Your message has been sent!",1);
            }
        } else {
            return $this->show_form($poll_id);
        }
    }

}

?>