<?php
/**
 * ----------------------------------------------
 * Advanced Poll 2.0 (PHP/MySQL)
 * Copyright (c)2001 Chi Kien Uong
 * URL: http://www.proxy2.de
 * ----------------------------------------------
 */

class poll_session {

    var $expire = 7200;
    var $table = array();
    var $db;

    function poll_session() {
        global $POLLTBL;
        $this->table = $POLLTBL;
    }

    function set_session_time($expire_time='') {
        if ($expire_time>0) {
            $this->expire = $expire_time;
        }
    }

    function is_valid_session($session,$user_id) {
        $this->db->query("SELECT session, LAST_VISIT from ".$this->table['poll_user']." WHERE session='$session' and user_id='$user_id'");
        $row = $this->db->fetch_array($this->db->result);
        if ($row) {
            $year = substr($row["LAST_VISIT"],0,4);
            $date = substr($row["LAST_VISIT"],4,10);
            $date_strg = chunk_split($date,2,"-");
            list($month,$day,$hour,$minute,$second) = explode("-",$date_strg);
            $tstamp = mktime($hour,$minute,$second,$month,$day,$year);
            return ($this->expire + $tstamp > time()) ? $row["session"] : false;
        } else {
            return false;
        }
    }

    function is_valid_user($user_id) {
        $this->db->query("SELECT username FROM ".$this->table['poll_user']." WHERE user_id='$user_id'");
        $this->db->fetch_array($this->db->result);
        return ($this->db->record) ? true : false;
    }

    function generate_new_session_id($user_id) {
        srand((double)microtime()*1000000);
        $session = md5 (uniqid (rand()));
        $this->db->query("UPDATE ".$this->table['poll_user']." SET session='$session' WHERE user_id='$user_id'");
        return $session;
    }

    function check_pass($username,$password) {
        $this->db->query("SELECT user_id FROM ".$this->table['poll_user']." WHERE username='$username' and userpass=PASSWORD('$password')");
        $this->db->fetch_array($this->db->result);
        return ($this->db->record) ? $this->db->record["user_id"] : false;
    }

    function check_session_id() {
        global $username, $password, $session, $uid;
        if (isset($session) && isset($uid)) {
            return ($this->is_valid_session($session,$uid)) ? array("session" => "$session", "uid" => "$uid") : false;
        } elseif (isset($username) && isset($password)) {
            if (!get_magic_quotes_gpc()) {
                $username = addslashes($username);
                $password = addslashes($password);
            }
            $ID = $this->check_pass($username,$password);
            if ($ID) {
                $session = $this->generate_new_session_id($ID);
                return array("session" => "$session", "uid" => "$ID");
            } else {
                return false;
            }
        } else {
            return false;
        }

    }

}

?>